import pyrda.sqlserver as sqlserver
import pyrdo.tuple as rdtpl
import pyrdo.array as rdarr
import pyrdo.list as rdlist


# test for function notation
def helloworld(txt: dict(type=str, help='input text')):
    print(txt)


# initial knowledge category in database
def initial_kc(conn, app_id: dict(type=str, help="the name of km app") = 'caas'):
    data = (app_id, '0', 'root', '-1', 0)
    sql = "insert into t_km_kc values('%s','%s','%s','%s',%s)" % data
    sqlserver.sql_insert(conn, sql)


def insert_kc(conn, data):
    sql = "insert into t_km_kc values('%s','%s','%s','%s',%s)" % data
    sqlserver.sql_insert(conn, sql)


# 批量插入数据，不做是否重复判定
def insert_kc_batch(conn, arrayData):
    for i in range(len(arrayData)):
        item = arrayData[i]
        data = rdtpl.list_as_tuple(item)
        insert_kc(conn, data)


def select_kc(conn, app_id):
    sql = "select * from t_km_kc where Fapp_id = '%s' " % app_id
    res = sqlserver.sql_select(conn, sql)
    # convert data from sql into array data
    res = rdarr.array_tupleItem_as_list(res)
    # print(sql)
    # print(res)
    return (res)


def upload_kc(conn, app_id, arrayData, id_index):
    old_data = select_kc(conn, app_id)
    new_data = arrayData
    diff_data = rdarr.array_diff(old_data, new_data, id_index)
    if len(diff_data) > 0:
        insert_kc_batch(conn, diff_data)
        res = True
    else:
        res = False
    return res
# 显示所有Fflag = 0 的列表
def kc_unSearched(conn,app_id):
    sql = "select Fid from t_km_kc where Fapp_id = '%s' and Fflag = 0" % app_id
    print(sql)
    res = sqlserver.sql_select(conn,sql)
    res = rdarr.array_tupleItem_as_list(res)
    data = []
    for i in range(len(res)):
        item = res[i][0]
        data.append(item)
    return(data)
# 设置知识分类已更新
def kc_updated(conn,app_id,fid):
    sql = "update a  set Fflag = 1 from t_km_kc a where Fapp_id = '%s' and Fid = '%s' and  Fflag = 0" % (app_id,fid)
    sqlserver.sql_update(conn,sql)
    # print(sql)
def kc_del(conn,app_id,fid):
    sql1 = "insert into t_km_kcDel select * from t_km_kc where Fapp_id ='%s' and Fid='%s'" % (app_id,fid)
    sqlserver.sql_exec(conn,sql1)
    sql2 = "delete  from t_km_kc where Fapp_id ='%s' and Fid='%s'" % (app_id,fid)
    sqlserver.sql_delete(conn,sql2)

if __name__ == '__main__':
    helloworld('hawken')
    print(helloworld.__annotations__)
    # 初始化数据知识分类数据
    conn = sqlserver.conn_create("115.159.201.178", "sa", "Hoolilay889@", "rdbe")
    app_id = "caas"
    # vinitial_kc(conn,app_id)
    # 测试分类数据上传
    #mydata = [['caas', '71688', '网商_test', '0', 0]]
    # insert_kc_batch(conn,mydata)
    # 测试查询
    kc_query = select_kc(conn, 'caas')
    print(kc_query)
    # print测试上传功能
    #up = upload_kc(conn,'caas',mydata,1)
    #print(up)
    # 处理字段查看
    #bbc = kc_unSearched(conn,'caas')
    #print(bbc)


    # 查看字段更新
    # kc_updated(conn,'caas','71688')
    # 删除字段
    kc_del(conn,'caas','707150')
    sqlserver.conn_close(conn)